
/****************************************************************

  File name   :  math_script_parser.h
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :  ѧű 
  Others      :  

*****************************************************************/

#ifndef __math_script_parser_H__
#define __math_script_parser_H__

// --------------------------------------------------------------------------------------

#include "value_node.h"
#include "operator.h"
#include <vector>

// --------------------------------------------------------------------------------------

namespace Why
{

class MathScriptParser
{
public:
    MathScriptParser()
    {
        memset(m_szParseInfo, 0, sizeof(m_szParseInfo));
        m_scriptBufPtr = NULL;
        m_scriptBufSize = 0;

        m_nVerticesCount = 0;
        m_nVerticesCountInDimension1 = 0;
        m_nVerticesCountInDimension2 = 0;
    }

    ~MathScriptParser()
    {
        Clear();
    }

    // ؽűļ
    bool LoadFile(const char* szFile);

    // ڴ
    bool ProcessMemory(const char* bufPtr, unsigned int bufSize);

    // ½(ʹıʽЧ)
    bool Reparse();

    void Clear();

    unsigned int GetVerticesCount() const;

    // ǷΪ2D
    bool IsValue2D() const;

    // ȡһάеĶĿ
    unsigned int GetVerticesCountInDimension1() const;

    // ȡڶάеĶĿ
    unsigned int GetVerticesCountInDimension2() const;
    
    // ȡڵΪ'a'-'z'
    const ValueNode* GetValueNode(char c) const;

    // ȡű
    unsigned int GetScriptLinesCount() const;

    // ȡĳһеĴ
    const char* GetScriptLine(unsigned int index) const;

    // ȡʱLOG
    const char* GetParseInfo() const;

    // ȡűС
    unsigned int GetScriptBufSize() const;

    // ȡűı
    void GetScriptBuffer(char* szBuffer, unsigned int bufSize) const;

    //ڵx,y,zǷЧ(ֻҪһЧ򷵻true)
    bool IsReadyXYZ() const;

    //ڵr,g,bǷЧ(Чʱŷtrue)
    bool IsValidRGB() const;

    //ڵuvǷЧ(Чʱŷtrue)
    bool IsValidUV() const;

    // ValueNodeʽ
    bool ParseExpression(const char* szExpression, ValueNode& rst);

private:    
    bool Parse();

    bool ParseLine(unsigned int line);

    bool ParseVerticesCount(const char* szExpression);

    bool ParseFromToSetting(const char* szExpression, ValueNode& rst);

    // ڵӱʽ
    bool ParseBracketExpression(const char* szExpression, unsigned int& pos, ValueNode& rst, 
        unsigned int bracketIndex, bool endComma);

    // ӱʽ
    bool ParseOperatorExpression(const char* szExpression, unsigned int& pos, 
        const Operator* operatorPtr, ValueNode& rst);

    // Ŀӱʽ
    bool ParseSingleOperatorExpression(const char* szExpression, unsigned int& pos, 
        SINGLE_OPERATOR_FUNC func, ValueNode& rst);

    // ˫Ŀӱʽ
    bool ParseTwinOperatorExpression(const char* szExpression, unsigned int& pos, 
        TWIN_OPERATOR_FUNC func, ValueNode& rst);

    // Ŀӱʽ
    bool ParseThreeOperatorExpression(const char* szExpression, unsigned int& pos, 
        THREE_OPERATOR_FUNC func, ValueNode& rst);

    // Ŀӱʽ
    bool ParseFourOperatorExpression(const char* szExpression, unsigned int& pos, 
        FOUR_OPERATOR_FUNC func, ValueNode& rst);

    // ڵӱʽ
    bool ParseValueNodeToFloatOperatorExpression(const char* szExpression, unsigned int& pos, 
        VALUENODE_TO_FLOAT_OPERATOR_FUNC func, ValueNode& rst);

    // ڵӱʽ
    bool ParseValueNodeConvertOperatorExpression(const char* szExpression, unsigned int& pos, 
        VALUENODE_CONVERT_OPERATOR_FUNC func, ValueNode& rst);

private:
    ValueNode m_listValueNode[26];                  // 26a-z

    char* m_scriptBufPtr;                           // űı
    unsigned int m_scriptBufSize;
    std::vector<const char*> m_vecScriptLines;
    unsigned int m_currentLine;

    unsigned int m_nVerticesCount;
    unsigned int m_nVerticesCountInDimension1;      // άʱ,1άֵĿ
    unsigned int m_nVerticesCountInDimension2;      // άʱ,2άֵĿ

    char m_szParseInfo[1024];
};

};

// --------------------------------------------------------------------------------------

#endif // __math_script_parser_H__
