
/****************************************************************

  File name   :  Common.cpp
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :   
  Others      :  

*****************************************************************/

// --------------------------------------------------------------------------------------

#include <cstdlib>
#include <cmath>
#include <cfloat>
#include <cstring>
#include <cstdio>
#include <assert.h>

#include "misc.h"
#include "common.h"

// --------------------------------------------------------------------------------------

#pragma warning(disable: 4996)
namespace Why
{

// --------------------------------------------------------------------------------------

unsigned int IsLeftBracketLetter(char c)
{
    for (unsigned int i = 0; i < BRACKET_OPERATORS_COUNT; i++)
    {
        if (g_leftBracketOperator[i].szName[0] == c)
        {   
            return i;
        }
    }

    return -1;
}

unsigned int IsRightBracketLetter(char c)
{
    for (unsigned int i = 0; i < BRACKET_OPERATORS_COUNT; i++)
    {
        if (g_rightBracketOperator[i].szName[0] == c)
        {   
            return i;
        }
    }

    return -1;
}

const Operator* GetLeftBracketOperator(const char* szExpression, unsigned int& pos, unsigned int& index)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    char cOperator = szExpression[pos];
    for (unsigned int i = 0; i < BRACKET_OPERATORS_COUNT; i++)
    {
        if (g_leftBracketOperator[i].szName[0] == cOperator)
        {
            index = i;
            pos++;
            return g_leftBracketOperator + i;
        }
    }

    return NULL;
}

const Operator* GetRightBracketOperator(const char* szExpression, unsigned int& pos, unsigned int& index)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    char cOperator = szExpression[pos];
    for (unsigned int i = 0; i < BRACKET_OPERATORS_COUNT; i++)
    {
        if (g_rightBracketOperator[i].szName[0] == cOperator)
        {
            index = i;
            pos++;
            return g_rightBracketOperator + i;
        }
    }

    return NULL;
}

const Operator* GetStandardSingleOperator(const char* szExpression, unsigned int& pos)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    char cOperator = szExpression[pos];
    for (unsigned int i = 0; i < STANDARD_SINGLE_OPERATORS_COUNT; i++)
    {
        if (g_standardSingleOperators[i].szName[0] == cOperator)
        {
            pos++;
            return g_standardSingleOperators + i;
        }
    }

    return NULL;
}

const Operator* GetStandardTwinOperator(const char* szExpression, unsigned int& pos)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    char cOperator = szExpression[pos];
    for (unsigned int i = 0; i < STANDARD_TWIN_OPERATORS_COUNT; i++)
    {
        if (g_standardTwinOperators[i].szName[0] == cOperator)
        {
            pos++;
            return g_standardTwinOperators + i;
        }
    }

    return NULL;
}

bool GetWord(char* szWord, const char* szExpression, unsigned int& pos)
{
    szWord[0] = 0;

    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    int index = 0;
    while (!is_separator(szExpression[pos]) && index < MAX_WORD_LENGTH - 1)
    {
        szWord[index] = szExpression[pos];
        index++;
        pos++;
    }
    szWord[index] = 0;

    return szWord[0] != 0;
}

// Ҷ
bool GetCommaOperator(const char* szExpression, unsigned int& pos)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    if (',' == szExpression[pos])
    {
        pos++;
        return true;
    }

    return false;
}

// ҵȺ
bool GetEqualOperator(const char* szExpression, unsigned int& pos)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    if ('=' == szExpression[pos])
    {
        pos++;
        return true;
    }

    return false;
}

// ð
bool GetColonOperator(const char* szExpression, unsigned int& pos)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    if (':' == szExpression[pos])
    {
        pos++;
        return true;
    }

    return false;
}

// Ҳ x,y,z
char GetParameter(const char* szWord)
{
    if (!is_separator(szWord[1]))
    {
        return 0;
    }

    char c = szWord[0];
    if (c >= 'a' && c <= 'z')
    {
        return c;
    }
    else
    {
        return 0;
    }
}

bool GetFloatValue(const char* szWord, float& rst)
{
    if (!is_number(szWord[0]))
    {
        return false;
    }

    char szValue[64];
    memset(szValue, 0, 64);
    unsigned int valueLen = 0;

    bool dot = false;

    for (valueLen = 0; valueLen < 63; valueLen++)
    {
        if (szWord[valueLen] == 0)
        {
            break;
        }
        else if (szWord[valueLen] == '.')
        {
            if (dot)
            {
                return false;
            }
            dot = true;
        }
        else if (!is_number(szWord[valueLen]))
        {
            return false;
        }

        szValue[valueLen] = szWord[valueLen];
    }

    if (!dot)
    {
        return false;
    }

    rst = (float)::atof(szValue);

    return true;
}

bool GetIntegerValue(const char* szWord, float& rst)
{
    if (!is_number(szWord[0]))
    {
        return false;
    }

    int tmp;
    if (string_to_int(szWord, tmp))
    {
        rst = (float)tmp;
        return true;
    }
    else
    {
        return false;
    }
}

bool GetIntegerValue(int& rst, const char* szExpression, unsigned int& pos)
{
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    if (!is_number(szExpression[pos]))
    {
        return false;
    }

    char szValue[64];
    memset(szValue, 0, 64);
    unsigned int valueLen = 0;

    bool dot = false;

    for (valueLen = 0; valueLen < 63; valueLen++)
    {
        if (is_separator(szExpression[pos + valueLen]))
        {
            break;
        }
        szValue[valueLen] = szExpression[pos + valueLen];
    }

    if (string_to_int(szValue, rst))
    {
        pos += valueLen;
        return true;
    }
    else
    {
        return false;
    }
}

// ѧʽĸ
bool GetScientificFloat(float& rst, const char* szExpression, unsigned int& position)
{
    unsigned int pos = position;
    while (szExpression[pos] == ' ')
    {
        pos++;
    }

    bool nv = false;
    if (szExpression[pos] == '-')
    {
        nv = true;
        pos++;
    }
    else if (szExpression[pos] == '+')
    {
        pos++;
    }

    if (!is_number(szExpression[pos]))
    {
        return false;
    }

    char szValue[64];
    memset(szValue, 0, 64);
    unsigned int i = 0;

    const char* szWord = szExpression + pos;

    bool dot = false;

    for (i = 0; i < 63; i++)
    {
        if (szWord[i] == '.')
        {
            if (dot)
            {
                // '.',ʧ
                return false;
            }
            dot = true;
        }
        else if (!is_number(szWord[i]))
        {
            break;
        }

        szValue[i] = szWord[i];
    }

    if (!dot)
    {
        // ûе'.',ʧ
        return false;
    }

    rst = (float)::atof(szValue);

    if (szWord[i] != 'e' && szWord[i] != 'E')
    {
        return false;
    }
    i++;

    bool sub = false;
    if (szWord[i] == '+')
    {
        i++;
    }
    else if (szWord[i] == '-')
    {
        i++;
        sub = true;
    }

    int j = 0;
    memset(szValue, 0, 64);
    while(!is_separator(szWord[i]))
    {
        if (!is_number(szWord[i]))
        {
            return false;
        }
        szValue[j] = szWord[i];
        j++;
        i++;
    }
    int e = ::atoi(szValue);

    if (sub)
    {
        for (int k = 0; k < e; k++)
        {
            rst /= 10.0f;
        }
    }
    else
    {
        for (int k = 0; k < e; k++)
        {
            rst *= 10.0f;
        }
    }

    if (nv)
    {
        rst = -rst;
    }

    pos += i;

    position = pos;

    return true;
}

};

// --------------------------------------------------------------------------------------
