
/****************************************************************

  File name   :  math_expression_parser.cpp
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/01/08 
  Description :  ѧʽ 
  Others      :  

*****************************************************************/

// --------------------------------------------------------------------------------------

#include "common.h"
#include "math_expression_parser.h"
#include <assert.h>

// --------------------------------------------------------------------------------------

#pragma warning(disable: 4996)
namespace Why
{

// --------------------------------------------------------------------------------------

float g_parameterValues[26] = {0.0f};

// --------------------------------------------------------------------------------------

// ӱʽ
bool ParseOperatorExpression(const char* szExpression, unsigned int& pos, 
    const Operator* operatorPtr, float& rst);

// Ŀӱʽ
bool ParseSingleOperatorExpression(const char* szExpression, unsigned int& pos, 
    SINGLE_OPERATOR_FUNC func, float& rst);

// ˫Ŀӱʽ
bool ParseTwinOperatorExpression(const char* szExpression, unsigned int& pos, 
    TWIN_OPERATOR_FUNC func, float& rst);

// Ŀӱʽ
bool ParseThreeOperatorExpression(const char* szExpression, unsigned int& pos, 
    THREE_OPERATOR_FUNC func, float& rst);

// Ŀӱʽ
bool ParseFourOperatorExpression(const char* szExpression, unsigned int& pos, 
    FOUR_OPERATOR_FUNC func, float& rst);

// --------------------------------------------------------------------------------------

// òֵ
void SetParameterValue(char c, float value)
{
    if (c >= 'a' && c <= 'z')
    {
        g_parameterValues[c - 'a'] = value;
    }
}

// ղֵ
void ClearParameterValues()
{
    memset(g_parameterValues, 0, sizeof(g_parameterValues));
}

// ʽ
bool ParseExpression(const char* szExpression, float& rst)
{
    rst = 0.0f;
    if (!szExpression || !szExpression[0])
    {
        return false;
    }

    unsigned int lenExp = strlen(szExpression);
    unsigned int pos = 0;

    // ֵ
    float listValues[3];
    memset(listValues, 0, sizeof(listValues));
    unsigned int valuesCount = 0;

    // ׼Ŀ
    const Operator* standardSingleOperator = NULL;

    // ׼Ŀ
    const Operator* standardTwinOperators[2];
    memset(standardTwinOperators, 0, sizeof(standardTwinOperators));
    unsigned int operatorsCount = 0;

    standardSingleOperator = GetStandardSingleOperator(szExpression, pos);

    char szWord[MAX_WORD_LENGTH];

    while (pos < lenExp)
    {
        if (valuesCount > operatorsCount)
        {
            const Operator* operatorPtr = GetStandardTwinOperator(szExpression, pos);
            if (!operatorPtr)
            {
                if (pos >= lenExp)
                {
                    // ʽĸǿո,Ҫ
                    break;
                }
                else
                {
                    return false;
                }
            }

            if (operatorsCount == 1)
            {
                if (operatorPtr->szName[0] == '+' || operatorPtr->szName[0] == '-')
                {
                    listValues[0] = standardTwinOperators[0]->twin_func(listValues[0], listValues[1]);
                    standardTwinOperators[0] = operatorPtr;
                    valuesCount--;
                }
                else
                {
                    standardTwinOperators[operatorsCount] = operatorPtr;
                    operatorsCount++;
                }
            }
            else
            {
                standardTwinOperators[operatorsCount] = operatorPtr;
                operatorsCount++;
            }
        }
        else
        {
            bool ableValue = false;
            float _value = 0.0f;

            // 
            {
                unsigned int bracketIndex;
                const Operator* operatorPtr = GetLeftBracketOperator(szExpression, pos, bracketIndex);
                if (operatorPtr)
                {
                    if (!ParseBracketExpression(szExpression, pos, _value, bracketIndex, false))
                    {
                        return false;
                    }
                    ableValue = true;
                }
            }

            // ѧʽĸ
            if (!ableValue)
            {
                ableValue = GetScientificFloat(_value, szExpression, pos);
            }

            // ȡǰ
            if (!ableValue && !GetWord(szWord, szExpression, pos))
            {
                return false;
            }

            // 
            if (!ableValue)
            {
                ableValue = GetConstValue(szWord, _value);
            }

            // ֵ
            if (!ableValue)
            {
                ableValue = GetIntegerValue(szWord, _value);
            }

            // ֵ
            if (!ableValue)
            {
                ableValue = GetFloatValue(szWord, _value);
            }

            // ֵ
            if (!ableValue)
            {
                char _param = szWord[1] == 0 ? szWord[0] : 0;
                if (_param)
                {
                    _value = g_parameterValues[_param - 'a'];
                    ableValue = true;
                }
            }  

            // 
            if (!ableValue)
            {
                const Operator* operatorPtr = GetFunctionOperator(szWord);
                if (operatorPtr)
                {
                    if (!ParseOperatorExpression(szExpression, pos, operatorPtr, _value))
                    {
                        return false;
                    }
                    ableValue = true;
                }
            }

            if (!ableValue)
            {
                return false;
            }

            if (operatorsCount == 2)
            {
                assert(valuesCount == 2);
                listValues[valuesCount] = _value;
                const Operator* operatorPtr = standardTwinOperators[1];
                listValues[1] = operatorPtr->twin_func(listValues[1], listValues[2]);
                operatorsCount--;
            }
            else if (operatorsCount == 1)
            {
                assert(valuesCount == 1);
                listValues[valuesCount] = _value;
                const Operator* operatorPtr = standardTwinOperators[0];
                if (operatorPtr->szName[0] != '+' && operatorPtr->szName[0] != '-')
                {
                    listValues[0] = operatorPtr->twin_func(listValues[0], listValues[1]);
                    operatorsCount--;
                }
                else
                {
                    valuesCount++;
                }
            }
            else if (operatorsCount == 0)
            {
                assert(valuesCount == 0);
                listValues[valuesCount] = _value;

                if (standardSingleOperator)
                {
                    listValues[0] = standardSingleOperator->single_func(listValues[0]);
                    standardSingleOperator = NULL;
                }

                valuesCount++;
            }
            else
            {
                assert(0);
            }
        }
    }

    if (valuesCount != operatorsCount + 1)
    {
        return false;
    }

    if (operatorsCount == 1)
    {
        const Operator* operatorPtr = standardTwinOperators[0];
        listValues[0] = operatorPtr->twin_func(listValues[0], listValues[1]);
        operatorsCount--;
        valuesCount--;
    }

    rst = listValues[0];

    return true;
}

// --------------------------------------------------------------------------------------

// ڵӱʽ
bool ParseBracketExpression(
    const char* szExpression, unsigned int& pos, float& rst, 
    unsigned int bracketIndex, bool endComma)
{
    rst = 0.0f;

    int nLeftBracket = 1;
    unsigned int bracketIndices[MAX_BRACKET_SIZE];
    bracketIndices[0] = bracketIndex;

    char szSubExp[SUB_EXPRESSION_MAX_LENGTH];
    memset(szSubExp, 0, SUB_EXPRESSION_MAX_LENGTH);

    unsigned int leftBI;
    unsigned int rightBI;

    unsigned int subExpLen = 0;
    while (szExpression[pos + subExpLen])
    {
        leftBI = IsLeftBracketLetter(szExpression[pos + subExpLen]);
        rightBI = IsRightBracketLetter(szExpression[pos + subExpLen]);

        if (leftBI != -1)
        {
            if (nLeftBracket > MAX_BRACKET_SIZE - 1)
            {
                return false;
            }
            bracketIndices[nLeftBracket] = leftBI;
            nLeftBracket++;
        }
        else if (rightBI != -1)
        {
            nLeftBracket--;
            if (bracketIndices[nLeftBracket] != rightBI)
            {
                return false;
            }
        }
        else if (endComma && szExpression[pos + subExpLen] == ',')
        {
            // Զβ
            if (nLeftBracket == 1)
            {
                nLeftBracket--;
            }
            else
            {
                return false;
            }
        }

        if (nLeftBracket == 0)
        {
            break;
        }
        szSubExp[subExpLen] = szExpression[pos + subExpLen];
        subExpLen++;
    }

    if (nLeftBracket != 0)
    {
        return false;
    }

    pos += subExpLen + 1;

    return ParseExpression(szSubExp, rst);
}

// ӱʽ
bool ParseOperatorExpression(
    const char* szExpression, unsigned int& pos, 
    const Operator* operatorPtr, float& rst)
{
    switch (operatorPtr->type)
    {
    case OT_STANDARD_SINGLE:
    case OT_SINGLE:
        return ParseSingleOperatorExpression(szExpression, pos, operatorPtr->single_func, rst);
        break;
    case OT_STANDARD_TWIN:
    case OT_TWIN:
        return ParseTwinOperatorExpression(szExpression, pos, operatorPtr->twin_func, rst);
        break;
    case OT_THREE:
        return ParseThreeOperatorExpression(szExpression, pos, operatorPtr->three_func, rst);
        break;
    case OT_FOUR:
        return ParseFourOperatorExpression(szExpression, pos, operatorPtr->four_func, rst);
        break;
    default:
        return false;
    }
}

// Ŀӱʽ
bool ParseSingleOperatorExpression(
    const char* szExpression, unsigned int& pos, 
    SINGLE_OPERATOR_FUNC func, float& rst)
{
    rst = 0.0f;
    if (!func)
    {
        assert(0);
        return false;
    }

    unsigned int bracketIndex;
    if (!GetLeftBracketOperator(szExpression, pos, bracketIndex))
    {
        return false;
    }

    if (!ParseBracketExpression(szExpression, pos, rst, bracketIndex, false))
    {
        return false;
    }

    rst = func(rst);

    return true;
}

// ˫Ŀӱʽ
bool ParseTwinOperatorExpression(
    const char* szExpression, unsigned int& pos, 
    TWIN_OPERATOR_FUNC func, float& rst)
{
    rst = 0.0f;
    if (!func)
    {
        return false;
    }

    unsigned int bracketIndex;
    if (!GetLeftBracketOperator(szExpression, pos, bracketIndex))
    {
        assert(0);
        return false;
    }

    float valueLeft;
    if (!ParseBracketExpression(szExpression, pos, valueLeft, bracketIndex, true))
    {
        return false;
    }

    float valueRight;
    if (!ParseBracketExpression(szExpression, pos, valueRight, bracketIndex, false))
    {
        return false;
    }

    rst = func(valueLeft, valueRight);

    return true;
}

// Ŀӱʽ
bool ParseThreeOperatorExpression(
    const char* szExpression, unsigned int& pos, 
    THREE_OPERATOR_FUNC func, float& rst)
{
    rst = 0.0f;
    if (!func)
    {
        assert(0);
        return false;
    }

    unsigned int bracketIndex;
    if (!GetLeftBracketOperator(szExpression, pos, bracketIndex))
    {
        return false;
    }

    float value1;
    if (!ParseBracketExpression(szExpression, pos, value1, bracketIndex, true))
    {
        return false;
    }

    float value2;
    if (!ParseBracketExpression(szExpression, pos, value2, bracketIndex, true))
    {
        return false;
    }

    float value3;
    if (!ParseBracketExpression(szExpression, pos, value3, bracketIndex, false))
    {
        return false;
    }

    rst = func(value1, value2, value3);

    return true;
}

// Ŀӱʽ
bool ParseFourOperatorExpression(
    const char* szExpression, unsigned int& pos, 
    FOUR_OPERATOR_FUNC func, float& rst)
{
    rst = 0.0f;
    if (!func)
    {
        assert(0);
        return false;
    }

    unsigned int bracketIndex;
    if (!GetLeftBracketOperator(szExpression, pos, bracketIndex))
    {
        return false;
    }

    float value1;
    if (!ParseBracketExpression(szExpression, pos, value1, bracketIndex, true))
    {
        return false;
    }

    float value2;
    if (!ParseBracketExpression(szExpression, pos, value2, bracketIndex, true))
    {
        return false;
    }

    float value3;
    if (!ParseBracketExpression(szExpression, pos, value3, bracketIndex, true))
    {
        return false;
    }

    float value4;
    if (!ParseBracketExpression(szExpression, pos, value4, bracketIndex, false))
    {
        return false;
    }

    rst = func(value1, value2, value3, value4);

    return true;
}

};