
/****************************************************************

  File name   :  misc.cpp
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :   
  Others      :  

*****************************************************************/

// --------------------------------------------------------------------------------------

#include <stdlib.h>
#include <string.h>
#include "misc.h"

// --------------------------------------------------------------------------------------

namespace Why
{

// --------------------------------------------------------------------------------------

unsigned int get_string_hash(const char *str)
{
    unsigned int hval = 0;
    if (!str)
    {
        return hval;
    }
    char c;
    while(*str != '\0')
    {
        c = *str;
        hval = (hval<<4) + (unsigned int)c;
        unsigned long g = hval & ((unsigned int) 0xf << (32 - 4));
        if(g != 0)
        {
            hval ^= g >> (32 - 8);
            hval ^= g;
        }
        str++;
    }
    return hval;
}


// ַת,֧2,8,10,16ֽ
/*
    0XͷΪ16, XABCDEFСд, 0xffff   
    0YͷΪ2, YСд, 0y10101010000
    0ͷΪ8, 07523, ע"08"֮ʧ
    ĬΪ10
*/
bool     string_to_int(const char* szSrc, int& rst)
{
    rst = 0;

    char* str = (char*)szSrc;
    if(str[0] == '0')
    {
        if (str[1] == 'x' || str[1] == 'X')
        {
            // 16
            str += 2;
            int nDecNum;
            int len = (int)strlen(str);
            int n = 1;
            for(int i = len - 1; i >= 0; i--)
            {
                switch(str[i])
                {
                case 'a':
                case 'A':
                    nDecNum = 10;
                    break;
                case 'b':
                case 'B':
                    nDecNum = 11;
                    break;
                case 'c':
                case 'C':
                    nDecNum = 12;
                    break;
                case 'd':
                case 'D':
                    nDecNum = 13;
                    break;
                case 'e':
                case 'E':
                    nDecNum = 14;
                    break;
                case 'f':
                case 'F':
                    nDecNum = 15;
                    break;
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                    nDecNum = str[i] - '0';
                    break;
                default:
                    return false;
                }
                rst += nDecNum * n;
                n *= 16;
            }
            return true;
        }
        else if (str[1] == 'y' || str[1] == 'Y')
        {
            // 2
            str += 2;
            int len = (int)strlen(str);
            int n = 1;
            for(int i = len - 1; i >= 0; i--)
            {
                if (str[i] == '1')
                {
                    rst += n;
                }
                else if (str[i] != '0')
                {
                    return false;
                }
                n *= 2;
            }
            return true;
        }
        else
        {
            // 8
            str += 1;
            int nDecNum;
            int len = (int)strlen(str);
            int n = 1;
            for(int i = len - 1; i >= 0; i--)
            {
                nDecNum = str[i] - '0';
                if (nDecNum > 7 || nDecNum < 0)
                {
                    return false;
                }
                rst += nDecNum * n;
                n *= 8;
            }
            return true;
        }
    }
    else
    {
        int len = (int)strlen(str);
        for (int i = 0; i < len; i++)
        {
            if (!is_number(str[i]))
            {
                return false;
            }
        }
        // 10
        rst = ::atoi(str);
        return true;
    }
}

// תΪһƵַ
void int_to_string(int value, char* szDest, int type)
{
    bool negative;
    if (value < 0)
    {
        negative = true;
        value = -value;
    }

    int index = 0;
    int nDecNum;
    char szTmp[128];
    memset(szTmp, 0, 128);
    while (value && index < 128)
    {
        nDecNum = value % type;
        value /= type;
        if (nDecNum < 10)
        {
            szTmp[index] = '0' + nDecNum;
        }
        else
        {
            szTmp[index] = 'A' + nDecNum - 10;
        }
        index++;
    }

    int pos = 0;
    if (negative)
    {
        szDest[pos] = '-';
        pos++;
    }
    for (int i = index - 1; i >= 0; i--)
    {
        szDest[pos] = szTmp[i];
        pos++;
    }
    szDest[pos] = 0;
}

// --------------------------------------------------------------------------------------

};