
/****************************************************************

  File name   :  operator.h
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :   
  Others      :  

*****************************************************************/

#ifndef __operator_H__
#define __operator_H__

// --------------------------------------------------------------------------------------

#define OPERATOR_NAME_LENGTH        24                      // 󳤶
#define MAX_FUNCTIONS_COUNT         256                     // 㺯Ŀ

// --------------------------------------------------------------------------------------

namespace Why
{

struct ValueNode;

// Ŀ㺯
typedef float (*SINGLE_OPERATOR_FUNC)(float);

// ˫Ŀ㺯
typedef float (*TWIN_OPERATOR_FUNC)(float, float);

// Ŀ㺯
typedef float (*THREE_OPERATOR_FUNC)(float, float, float);

// Ŀ㺯
typedef float (*FOUR_OPERATOR_FUNC)(float, float, float, float);

// ValueNode㺯(ValueNode,һ)
typedef float (*VALUENODE_TO_FLOAT_OPERATOR_FUNC)(const ValueNode*);

// ValueNode㺯(ValueNode,ValueNode)
typedef void  (*VALUENODE_CONVERT_OPERATOR_FUNC)(const ValueNode*, ValueNode*);

// --------------------------------------------------------------------------------------

// 
enum OperatorType
{
    OT_INVALID              = 0,

    OT_STANDARD_SINGLE      = 1,    // ׼Ŀ -a
    OT_STANDARD_TWIN        = 2,    // ׼˫Ŀ a+b
    OT_LEFT_BRACKET         = 3,    // 
    OT_RIGHT_BRACKET        = 4,    // 

    OT_SINGLE               = 5,    // Ŀ sin(a)
    OT_TWIN                 = 6,    // ˫Ŀ pow(a, b)
    OT_THREE                = 7,    // Ŀ lerp(a, b, r)
    OT_FOUR                 = 8,    // Ŀ average4(a, b, c, d)
    OT_VALUENODE_TO_FLOAT   = 9,    // ValueNode(ValueNode,һ)
    OT_VALUENODE_CONVERT    = 10,   // ValueNode(ValueNode,ValueNode)
};

// ṹ
struct Operator
{
    char szName[OPERATOR_NAME_LENGTH];
    unsigned int hash;
    OperatorType type;

    SINGLE_OPERATOR_FUNC    single_func;
    TWIN_OPERATOR_FUNC      twin_func;
    THREE_OPERATOR_FUNC     three_func;
    FOUR_OPERATOR_FUNC      four_func;
    VALUENODE_TO_FLOAT_OPERATOR_FUNC value_node_to_float_func;
    VALUENODE_CONVERT_OPERATOR_FUNC  value_node_convert_func;
};

// --------------------------------------------------------------------------------------

// ׼Ŀ
#define STANDARD_SINGLE_OPERATORS_COUNT 2
#define STANDARD_TWIN_OPERATORS_COUNT   6  
#define BRACKET_OPERATORS_COUNT         3  

// ׼
extern const Operator g_standardSingleOperators[STANDARD_SINGLE_OPERATORS_COUNT];
extern const Operator g_standardTwinOperators[STANDARD_TWIN_OPERATORS_COUNT];
extern const Operator g_leftBracketOperator[BRACKET_OPERATORS_COUNT];
extern const Operator g_rightBracketOperator[BRACKET_OPERATORS_COUNT];

// --------------------------------------------------------------------------------------

// 㺯
extern Operator       g_arrayFunctionOperators[MAX_FUNCTIONS_COUNT];
extern unsigned int   g_countFunctionOperators;

// ʼ㺯
void InitFunctionOperators();

// ӻ㺯
bool SetSingleOperator(const char* szName, SINGLE_OPERATOR_FUNC func);
bool SetTwinOperator(const char* szName, TWIN_OPERATOR_FUNC func);
bool SetThreeOperator(const char* szName, THREE_OPERATOR_FUNC func);
bool SetFourOperator(const char* szName, FOUR_OPERATOR_FUNC func);
bool SetValueNodeToFloatOperator(const char* szName, VALUENODE_TO_FLOAT_OPERATOR_FUNC func);
bool SetValueNodeConvertOperator2(const char* szName, VALUENODE_CONVERT_OPERATOR_FUNC func);

// ȡ㺯
const Operator* GetFunctionOperator(const char* szName);

};

// --------------------------------------------------------------------------------------

#endif // __operator_H__
