
/****************************************************************

  File name   :  MathExpressionCommon.h
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/01/08 
  Description :   
  Others      :  

*****************************************************************/

#ifndef __MathExpressionCommon_H__
#define __MathExpressionCommon_H__

// --------------------------------------------------------------------------------------

#define NAME_MAX_LENGTH             10          // ͳ󳤶
#define SUB_EXPRESSION_MAX_LENGTH   256         // ӱʽ󳤶
#define MAX_BRACKET_SIZE            32          // ŵǶ

// --------------------------------------------------------------------------------------

// 

#define CONST_VALUES_COUNT          2           // Ŀ

struct ConstValue
{
    char szName[NAME_MAX_LENGTH];               // 
    float value;                                // ֵ
};

extern const ConstValue g_constValues[CONST_VALUES_COUNT];     

// --------------------------------------------------------------------------------------

// Ŀ㺯
typedef float (*SINGLE_FUNC)(float);

// ˫Ŀ㺯
typedef float (*TWIN_FUNC)(float, float);

// Ŀ㺯
typedef float (*THREE_FUNC)(float, float, float);

// Ŀ㺯
typedef float (*FOUR_FUNC)(float, float, float, float);

// --------------------------------------------------------------------------------------

// 
enum OperatorType
{
    OT_INVALID          = 0,
    OT_STANDARD_SINGLE  = 1,    // ׼Ŀ -a
    OT_STANDARD_TWIN    = 2,    // ׼˫Ŀ a+b
    OT_SINGLE           = 3,    // Ŀ sin(a)
    OT_TWIN             = 4,    // ˫Ŀ pow(a, b)
    OT_THREE            = 5,    // Ŀ lerp(a, b, r)
    OT_FOUR             = 6,    // Ŀ average4(a, b, c, d)
    OT_LEFT_BRACKET     = 7,    // 
    OT_RIGHT_BRACKET    = 8,    // 
};

// ṹ
struct Operator
{
    char szName[NAME_MAX_LENGTH];
    unsigned int nameLen;
    OperatorType type;
    SINGLE_FUNC single_func;
    TWIN_FUNC twin_func;
    THREE_FUNC three_func;
    FOUR_FUNC four_func;
};

// Ŀ
#define STANDARD_SINGLE_OPERATORS_COUNT 2
#define STANDARD_TWIN_OPERATORS_COUNT   6  
#define SINGLE_OPERATORS_COUNT          18         
#define TWIN_OPERATORS_COUNT            10      
#define THREE_OPERATORS_COUNT           5         
#define FOUR_OPERATORS_COUNT            2        

// 
extern const Operator g_standardSingleOperators[STANDARD_SINGLE_OPERATORS_COUNT];
extern const Operator g_standardTwinOperators[STANDARD_TWIN_OPERATORS_COUNT];
extern const Operator g_singleOperators[SINGLE_OPERATORS_COUNT];
extern const Operator g_twinOperators[TWIN_OPERATORS_COUNT];
extern const Operator g_threeOperators[THREE_OPERATORS_COUNT];
extern const Operator g_fourOperators[FOUR_OPERATORS_COUNT];
extern const Operator g_leftBracketOperator;
extern const Operator g_rightBracketOperator;

// --------------------------------------------------------------------------------------

// 

float     yf_positive(float a);
float     yf_negative(float a);

float     yf_add(float a, float b);
float     yf_sub(float a, float b);
float     yf_multiply(float a, float b);
float     yf_divide(float a, float b);

float     yf_abs(float a);
float     yf_floor(float a);
float     yf_ceil(float a);
float     yf_sign(float a);
float     yf_sqrt(float a);
float     yf_exp(float a);
float     yf_log(float a);
float     yf_log2(float a);
float     yf_log10(float a);
float     yf_sin(float a);
float     yf_cos(float a);
float     yf_tan(float a);
float     yf_asin(float a);
float     yf_acos(float a);
float     yf_atan(float a);
float     yf_rand(float a);

float     yf_max(float a, float b);
float     yf_min(float a, float b);
float     yf_mod(float a, float b);
float     yf_pow(float a, float b);
float     yf_atan2(float a, float b);
float     yf_rand2(float a, float b);

float     yf_lerp(float a, float b, float r);
float     yf_clamp(float v, float hi, float low);
float     yf_gray(float r, float g, float b);
float     yf_add3(float a, float b, float c);
float     yf_average3(float a, float b, float c);

float     yf_add4(float a, float b, float c, float d);
float     yf_average4(float a, float b, float c, float d);

// --------------------------------------------------------------------------------------

// ǷΪ
unsigned int IsLeftBracketLetter(char c);

// ǷΪ
unsigned int IsRightBracketLetter(char c);

// 
const Operator* GetLeftBracketOperator(const char* szExpression, unsigned int& pos, unsigned int& index);

// 
const Operator* GetRightBracketOperator(const char* szExpression, unsigned int& pos, unsigned int& index);

// ұ׼Ŀ
const Operator* GetStandardSingleOperator(const char* szExpression, unsigned int& pos);

// ұ׼˫Ŀ
const Operator* GetStandardTwinOperator(const char* szExpression, unsigned int& pos);

// ұ׼Ŀ
const Operator* GetSingleOperator(const char* szExpression, unsigned int& pos);

// ұ׼˫Ŀ
const Operator* GetTwinOperator(const char* szExpression, unsigned int& pos);

// ұ׼Ŀ
const Operator* GetThreeOperator(const char* szExpression, unsigned int& pos);

// ұ׼Ŀ
const Operator* GetFourOperator(const char* szExpression, unsigned int& pos);

// Ҷ
bool GetCommaOperator(const char* szExpression, unsigned int& pos);

// Ҳ x,y,z
char GetParameter(const char* szExpression, unsigned int& pos);

// ȡֵ
bool GetConstValue(float& rst, const char* szExpression, unsigned int& pos);

// ȡֵ
bool GetFloatValue(float& rst, const char* szExpression, unsigned int& pos);

// ȡֵ
bool GetIntegerValue(float& rst, const char* szExpression, unsigned int& pos);

// --------------------------------------------------------------------------------------

#endif // __MathExpressionParser_H__
